
var OPML_FILTER = new javax.swing.filechooser.FileNameExtensionFilter("OPMLファイル", "opml");
var APP_NAME = "OPMLサポート";
 

// よく使う関数をまとめたjsファイルをインポート
// ext直下ではないjsファイルはimportFileでロードし使用することができる
importFile("lib/utils.js");

customizeMenu();

/**
 * メニューをカスタマイズします。
 */
function customizeMenu()
{
    var menu = window.menu;
    var file = menu.file;

    var recentMenuItem = getFormatMenuItem();
    if(recentMenuItem == null) {
        alert("メニュー構成の探索に失敗しました。");
        return;
    }
    // 階層型メニューを構築
    var container = menu.createMenuContainer("OPML形式");
    container.icon = "jp/carabiner/tarp/desktop/icons/page_white_text.png";
    container.tooltips = "OPML形式でのインポート・エクスポート";
    file.insertBefore(container, recentMenuItem);
    
    var comp = menu.createMenuItem("OPMLファイルをインポート", importOPML);
    container.appendChild(comp);
    
    comp = menu.createMenuItem("OPMLファイルをエクスポート", exportOPML);
    container.appendChild(comp);
    
    // formatManagerの登録
    var formatManager = window.formatManager;
    var format = formatManager.createFormat([".opml"]);
    format.description = "OPMLファイル";
    format.loadCallback = function(context) {
    	var model = context.createModel();
        var node = Packages.jp.carabiner.beitel.app.opml.JSOPML.openOPML(window, model, context.path);
    	model.rootNode = node;
    };
    format.saveCallback = function(context) {
    	var model = context.model;
        Packages.jp.carabiner.beitel.app.opml.JSOPML.exportOPML(window, model, context.path);
    };
	format.loadConfirmCallback = function(path) {
		return true;
	};
	format.saveConfirmCallback = function(path) {
		return confirm("OPML形式で保存する場合、書式情報が失われる場合があります。\nよろしいですか？");
	};
    formatManager.appendChild(format);
}

/**
 * OPMLをインポートします。
 * 
 * @param ev
 *            イベント。
 */
function importOPML(ev)
{
    var path = showOpenDialog([OPML_FILTER]);
    if(path == null) {
        return;
    }
    
    Packages.jp.carabiner.beitel.app.opml.JSOPML.importOPML(window, document, path);
    alert("OPMLファイルのインポートが完了しました: " + path);
}

/**
 * OPMLをエクスポートします。
 * 
 * @param ev
 *            イベント。
 */
function exportOPML(ev)
{
    var path = showSaveDialog([OPML_FILTER], "opml");
    if(path == null) {
        return;
    }
    
    Packages.jp.carabiner.beitel.app.opml.JSOPML.exportOPML(window, document, path);
    alert("OPMLファイルのエクスポートが完了しました: " + path);
}
