
importFile("lib/utils.js");

// 初期化
customizeHTMLMenu();

/**
* メニューをカスタマイズします。
*/
function customizeHTMLMenu()
{
    var menu = window.menu;
    var file = menu.file;

    var recentMenuItem = getFormatMenuItem();
    if(recentMenuItem == null) {
        alert("メニュー構成の探索に失敗しました。");
        return;
    }
    var comp = menu.createMenuItem("HTML出力", exportHTML);
    comp.icon = "jp/carabiner/tarp/desktop/icons/page_code.png";
    // comp.setKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.Event.SHIFT_MASK|java.awt.Event.CTRL_MASK);
    file.insertBefore(comp, recentMenuItem);
}

/**
* テキストをエクスポートします。
* @param ev イベント。
*/
function exportHTML(ev)
{
    var path = showSaveDialog();
    if(path == null) {
        return;
    }
    
    var file = new java.io.File(path);
    var fr = new java.io.FileWriter(file);
    var pr = new java.io.PrintWriter(fr);
    var context = new Object();
    context.imageCount = 1;

    pr.println("<html>");
    pr.println("  <head>");
    pr.println("    <title>サンプルデータ</title>");
    pr.println("  </head>");
    pr.println("  <body>");
    exportHTMLNode(pr, file.parentFile.absolutePath, ev.currentTarget, context);
    pr.println("  </body>");
    pr.println("</html>");
    pr.close();    
    alert("HTML出力が完了しました: " + path);
}

function exportHTMLNode(pr, parentPath, node, context)
{
    var ins = node.imageData;
    if(ins != null) {
        var suffixPos = node.imageFilename.lastIndexOf('.');
        var suffix = "";
        if(suffixPos > 0) {
            suffix = node.imageFilename.substring(suffixPos);
        }
        var subPath = "images/" + context.imageCount + suffix;
        context.imageCount ++;
        var file = new java.io.File(parentPath, subPath);
        file.parentFile.mkdirs();
        var outs = new java.io.BufferedOutputStream(new java.io.FileOutputStream(file));
        
        var ch = -1;
        while((ch = ins.read()) != -1) {
            outs.write(ch);
        }
        outs.flush();
        outs.close();
        ins.close();
        pr.println("<img src=\"" + subPath + "\"/>");
    }else{
    	pr.println("<div>" + node.HTML + "</div>");
    }
	pr.println("<ul>");
	var childNodes = node.childNodes;
	for(var i = 0; i < childNodes.length; i ++) {
	    var childNode = childNodes.item(i);
        pr.println("<li>");
        exportHTMLNode(pr, parentPath, childNode, context);
        pr.println("</li>");
	}
	pr.println("</ul>");
}